Attribute VB_Name = "Global"
Option Explicit

Public Enum enumSortOrders
    Ascending
    Descending
End Enum
         
' API
Public Const NORMAL_PRIORITY_CLASS = &H20&
Public Const INFINITE = -1&

Public Declare Function CreateProcessA Lib "kernel32" (ByVal lpApplicationName As Long, ByVal lpCommandLine As String, ByVal lpProcessAttributes As Long, ByVal lpThreadAttributes As Long, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, ByVal lpEnvironment As Long, ByVal lpCurrentDirectory As String, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long

'Windows version
Private Const dwMaskUnknown = &H0&
Private Const dwMask9x = &H1&     'Win95 et 98 renvoient 1
Private Const dwMaskNT = &H2&     'WinNT renvoie 2

Private Type OSVERSIONINFO 'for GetVersionEx API call
    dwOSVersionInfoSize         As Long
    dwMajorVersion              As Long
    dwMinorVersion              As Long
    dwBuildNumber               As Long
    dwPlatformID                As Long
    szCSDVersion                As String * 128
End Type

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long

Private Const OFS_MAXPATHNAME = 128
Public Type OFSTRUCT
    cBytes                  As Byte
    fFixedDisk              As Byte
    nErrCode                As Integer
    Reserved1               As Integer
    Reserved2               As Integer
    szPathName(OFS_MAXPATHNAME) As Byte
End Type

' OPENFILE_MODE
Public Const OF_CANCEL = &H800&
Public Const OF_CREATE = &H1000&
Public Const OF_DELETE = &H200&
Public Const OF_EXIST = &H4000&
Public Const OF_PARSE = &H100&
Public Const OF_PROMPT = &H2000&
Public Const OF_READ = &H0&
Public Const OF_READWRITE = &H2&
Public Const OF_REOPEN = &H8000&
Public Const OF_SHARE_COMPAT = &H0&
Public Const OF_SHARE_DENY_NONE = &H40&
Public Const OF_SHARE_DENY_READ = &H30&
Public Const OF_SHARE_DENY_WRITE = &H20&
Public Const OF_SHARE_EXCLUSIVE = &H10&
Public Const OF_VERIFY = &H400&
Public Const OF_WRITE = &H1&

' CreateFile access Flags
Public Const GENERIC_ALL = &H10000000
Public Const GENERIC_EXECUTE = &H20000000
Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000

Public Const OPEN_ALWAYS = 4&
Public Const OPEN_EXISTING = 3&
Public Const CREATE_ALWAYS = 2&

Public Declare Function OpenFile Lib "kernel32" (ByVal lpFileName As String, lpReOpenBuff As OFSTRUCT, ByVal wStyle As Long) As Long
Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Public Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, lpOverlapped As Any) As Long
Public Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, lpOverlapped As Any) As Long
Public Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, lpFileSizeHigh As Long) As Long

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Public Const SW_SHOWNORMAL = 1

Private Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Private Declare Function GetTempPathA Lib "kernel32" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Public Declare Function SetFocusA Lib "user32" Alias "SetFocus" (ByVal hWnd As Long) As Long

Public Function IsWin9x() As Boolean
    IsWin9x = (Not GetWinPlatform And dwMaskNT)
End Function

Private Function GetWinPlatform() As Long
    Dim tOSVI           As OSVERSIONINFO
    
On Error GoTo ErrorFlag

    tOSVI.dwOSVersionInfoSize = Len(tOSVI)
    If GetVersionEx(tOSVI) = 0 Then
        Exit Function
    End If
    GetWinPlatform = tOSVI.dwPlatformID

ErrorFlag:
End Function

Public Function GetTempPath() As String
    Dim lRc     As Long
    Dim strPath As String

On Error GoTo ErrorFlag

    strPath = String$(260, vbNullChar)
     
    lRc = GetTempPathA(260, strPath)
    If lRc <> 0 Then            ' Not error indicates success or small buffer
        If lRc <= 260 Then
            GetTempPath = Left$(strPath, lRc)
        Else
            GetTempPath = Left$(strPath, 260)   ' small buffer
        End If
    Else
        GetTempPath = vbNullString
    End If

Exit Function
ErrorFlag:
    Debug.Print "GetTempPath", "Erreur ", Err.Description, Err.Number
    Debug.Assert False
End Function

Public Function GetTempFile(Optional lUnique As Long = 0) As String
    Dim lRc         As Long
    Dim strFile     As String
    Dim strPref     As String
    Dim strPath     As String
    Dim lNullPos    As Long
    
On Error GoTo ErrorFlag

    GetTempFile = vbNullString
    strPath = GetTempPath
    strPref = App.EXEName
    strFile = String$(260, vbNullChar)
     
    lRc = GetTempFileName(strPath, strPref, lUnique, strFile)
    If lRc <> 0 Then            ' Not error indicates success or small buffer
        lNullPos = InStr(strFile, vbNullChar)
        If lNullPos > 0 Then
            GetTempFile = Left$(strFile, lNullPos - 1)
        End If
    End If

Exit Function
ErrorFlag:
    Debug.Print "GetTempFile", "Erreur ", Err.Description, Err.Number
    Debug.Assert False
End Function


